/*

  Nullsoft WASABI Source File License

  Copyright 1999-2001 Nullsoft, Inc.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Brennan Underwood
  brennan@nullsoft.com

*/

#ifndef _EXAMPLEBWNDCREATE_H
#define _EXAMPLEBWNDCREATE_H

#include "../studio/services/svc_wndcreate.h"
#include "../common/ptrlist.h"

//
//  This code is slated to be made generic and streamlined.
//
//  However, for now, if you want to make a window, this is how you do it.
//
//  In this file, just change the values of the Module-mobility #defines.
//

//
// Forward references.
class BucketGroup;
class BucketItem;

//
// Module-mobility #defines
#ifndef WAC_WNDCREATE

// Change these names for your specific project.
#   define WAC_WNDCREATE      ExampleBWndCreateSvc
#   define WAC_WC_SVC_NAME    _("Example B Window Creation Service")
#   define WAC_WC_BKT_NAME    _("Example B")

#else //WAC_WNDCREATE

#   pragma message ("Why the hell are you defining WAC_WNDCREATE twice?");

#endif//WAC_WNDCREATE

//
// The local Window Creation Module.
class WAC_WNDCREATE : public svc_windowCreateI {
  
  public:
    static const char *getServiceName() { return WAC_WC_SVC_NAME; }

    int testGuid(GUID g);
    RootWnd *createWindowByGuid(GUID g, RootWnd *parent);
    RootWnd *createWindowOfType(int windowtype, int n, RootWnd *parent);
    int destroyWindow(RootWnd *w);

  private:
    PtrList<RootWnd> bucketitem_list;
};

#endif//_EXAMPLEBWNDCREATE_H
