/*

  Nullsoft WASABI Source File License

  Copyright 1999-2001 Nullsoft, Inc.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Brennan Underwood
  brennan@nullsoft.com

*/

#ifndef _XMLOBJCB_H
#define _XMLOBJCB_H

// ==========================================================================
//
//	class XMLObjCallbackBase
//
//		Objects derived from this class are instantiated and passed to the
//		XML Object Instantiation Engine to selectively handle incoming tags
//

class XMLObjCallbackBase {
public:
	virtual int IncludeInternalMarkupAsCharData( void ) { return 0; }
	virtual int TestTag( const char * tag )							{ return 0; }
	virtual int TakeData( const char * data )						{ return 0; }
}



template < class T >
class XMLObjInstantiator : public XMLObjCallbackBase {
public:
	virtual int IncludeInternalMarkupAsCharData( void );
	virtual int TestTag( const char * tag );
	virtual int TakeData( const char * data );
}

#endif//_XMLOBJCB_H
